/*
**	memory allocation functions
*/

#define	NULL (char *)0

extern char *malloc(unsigned);

/*
**	pools are singly-linked lists of BLKSIZE blocks of memory
*/

#define	BLKSIZE	4096

typedef	struct BLKHDR {
	struct BLKHDR *next;
	short size;
	} BLKHDR;

#define	BTXTSIZE	BLKSIZE - sizeof(BLKHDR)

typedef struct {
	BLKHDR hdr;
	char text[BTXTSIZE];
	} BLK;

static BLK *beg, *end;

#define	nxt(p) (p)->hdr.next
#define	siz(p)	(p)->hdr.size
#define	txt(p)	&((p)->text[siz(p)])

/*
**	return a pointer to size bytes from pool
*/

char *palloc(unsigned short size) {
	BLK *sp;

	if(size > BTXTSIZE){
		if((sp = (BLK *)malloc(size + sizeof(BLKHDR))) == NULL)
			fatal("palloc: out of memory");
		siz(sp) = 0;
		nxt(sp) = NULL;
		if (end) nxt(end) = sp;
		end = sp;
		if(beg == NULL) beg = sp;
		return sp->text;
		}
	for(sp = beg; sp && siz(sp) < size; sp = nxt(sp))
		;
	if(sp == NULL)
		if((sp = (BLK *)malloc(BLKSIZE)) == NULL)
			fatal("palloc: out of memory");
		else {
			siz(sp) = BTXTSIZE;
			nxt(sp) = beg;
			beg = sp;
			if(end == NULL)
				end = sp;
			}
	siz(sp) -= size;
	return txt(sp);
	}
