/*	fopen.c - open file, return file pointer.
	(C) Copyright 1984 Gregory R. Mansfield - All Rights Reserved.
	G. R. Mansfield.  84/06/05.
	Ver 1.0-4728.
*/

#include <stdio.h>

FILE *fopen(name, mode)
register char *name, *mode;
{
	register int fd;
	register FILE *fp;

	if (*mode != 'r' && *mode != 'w' && *mode != 'a')
		return(NULL);
	for (fp = _iob; fp < _iob + _NFILE; fp++)
		if ((fp->_flag & (_READ | _WRITE)) == 0)
			break;	/* found free slot */
	if (fp >= _iob + _NFILE)	/* no free slots found */
		return(NULL);

	if (*mode == 'w')	/* access file */
		fd = creat(name, 0);
	else if (*mode == 'a') {
		if ((fd = open(name, 1)) == ERR)
			fd = creat(name, 0);
		lseek(fd, 0L, 2);
	}
	else
	fd = open(name, 0);
	if (fd == ERR)	/* couldn't access name */
		return(NULL);

	fp->_fd = fd;
	fp->_cnt = 0;
	fp->_base = NULL; 
	fp->_flag &= ~(_READ | _WRITE | _UNBUF);
	fp->_flag |= (*mode == 'r') ? _READ : _WRITE;	
	return(fp);
}
