/*	lctoa.c - long to ASCII conversion with ',' separators.
	(C) Copyright 1984 Gregory R. Mansfield - All Rights Reserved.
	G. R. Mansfield.  84/07/03.
	Ver 1.0-4809.
*/

lctoa(n, s) /* convert n to characters in s with ',' separators */
long n;
char *s;
{
	char c, *p;
	int i;

	if (n < 0) {	/* record sign */
		*s++ = '-';
		n = -n;	/* make n positive */
	}
	p = s;
	i = 0;
	do {	/* generate digits in reverse order */
		if (i++ == 3) {
			i = 1;
			*p++ = ',';
		}
		*p++ = n % 10L + '0';	/* get next digit */
	} while ((n /= 10L) > 0L);	/* delete it */
	*p = '\0';
	while (p > s) {	/* reverse string */
		c = *s;
		*s++ = *--p;
		*p = c;
	}
}
