#	Copyright(C) 1986 AT&T.  All Rights Reserved.

#	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T.
#	The copyright notice above does not evidence any actual
#	or intended publication of such source code.

#
# makefile for libm
#
# Note that the object list given in FILES is in the order in which the files
# should be added to the archive when it is created.  If the files are not
# ordered correctly, linking of libm fails on the pdp11 and is slowed down
# on other machines.

INC=$(ROOT)/usr/include
LIB=$(ROOT)/lib
LIBP=$(ROOT)/lib/libp
VARIANT =
LIBNAME = lib$(VARIANT)m.a
AR=
FILES =\
	$(LIBNAME)(asin.o)\
	$(LIBNAME)(atan2.o)\
	$(LIBNAME)(atan.o)\
	$(LIBNAME)(erf.o)\
	$(LIBNAME)(fabs.o)\
	$(LIBNAME)(floor.o)\
	$(LIBNAME)(fmod.o)\
	$(LIBNAME)(gamma.o)\
	$(LIBNAME)(hypot.o)\
	$(LIBNAME)(jn.o)\
	$(LIBNAME)(j0.o)\
	$(LIBNAME)(j1.o)\
	$(LIBNAME)(pow.o)\
	$(LIBNAME)(log.o)\
	$(LIBNAME)(log10.o)\
	$(LIBNAME)(sin.o)\
	$(LIBNAME)(cos.o)\
	$(LIBNAME)(sinh.o)\
	$(LIBNAME)(sqrt.o)\
	$(LIBNAME)(tan.o)\
	$(LIBNAME)(tanh.o)\
	$(LIBNAME)(exp.o)\
	$(LIBNAME)(matherr.o)

FLS =\
	$(LIBNAME)(atan.o)\
	$(LIBNAME)(pow.o)\
	$(LIBNAME)(log.o)\
	$(LIBNAME)(log10.o)\
	$(LIBNAME)(sin.o)\
	$(LIBNAME)(cos.o)\
	$(LIBNAME)(sqrt.o)\
	$(LIBNAME)(tan.o)\
	$(LIBNAME)(exp.o)

all: spreproc $(LIBNAME) profiledlib

$(LIBNAME): $(FILES)
		for i in $(?:.o=); do \
			if [ -f "$$i.s" ]; then \
				$(CC) -c $(CFLAGS) $$i.s; \
			else \
				if [ $(UX) = "unix" ] ; then \
					$(CC) -c $(CFLAGS) -DUNX $$i.c; \
				else \
					$(CC) -c $(CFLAGS) $$i.c; \
				fi; \
			fi; \
		done; \
	$(AR) rv $(LIBNAME) $?
	rm -f $?

$(FILES): $(INC)/math.h $(INC)/values.h $(INC)/errno.h \
		$(INC)/sys/errno.h

.c.a:;

profiledlib: ppreproc
	make -f libm.mk -e libp.$(LIBNAME) LIBNAME=libp.$(LIBNAME) \
						CFLAGS="-p $(CFLAGS)"

spreproc: $(FLS)
	if [ $(UX) = "unix" ] ; then \
		for i in $(?:.o=); do\
			m4 ../math.m ../m4.def -DMCOUNT=# -DUNX $$i.m > $$i.s; \
		done; \
		else \
		for i in $(?:.o=); do\
			m4 ../math.m ../m4.def -DMCOUNT=# $$i.m > $$i.s; \
		done; \
		fi;

ppreproc: $(FLS)
	if [ $(UX) = "unix" ] ; then \
		for i in $(?:.o=); do\
			m4 ../math.m ../m4.def ../mcount.def -DUNX $$i.m > $$i.s; \
		done; \
		else \
		for i in $(?:.o=); do\
			m4 ../math.m ../m4.def ../mcount.def $$i.m > $$i.s; \
		done; \
		fi;


install: all
	cp $(LIBNAME) $(LIB)/$(LIBNAME)
	cp libp.$(LIBNAME) $(LIBP)/$(LIBNAME)

clean:
	-rm -f *.o *.s

clobber:	clean
	-rm -f $(LIBNAME) libp.$(LIBNAME)
