#	Copyright(C) 1986 AT&T.  All Rights Reserved.

#	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T.
#	The copyright notice above does not evidence any actual
#	or intended publication of such source code.

	.file	"log10.c"
	.data
	.align	4

	.set	DEXP_BIAS,1023		# bias for double precision exponent
	.set	MAX_EXP,0x7ff		# reserved exponent for nan or infinity
	.set	DEXP_OFFSET,20		# bit offset where the exponent starts
	.set	DEXP_WIDTH,11		# width of double exponent
	.set	SIGN_MASK,0x7fffffff	# used to mask off the sign
	.set	SIGN_BIT,0x80000000	# to check sign bit
	.set	IMPLIED_BIT,0x100000	# to check implied bit
.COFF_P:
	.word	0xbfe94415,0xb356bd29	# -0.78956112887491247
	.word	0x4030624a,0x2016afed	# 16.383943563021535
	.word	0xc05007ff,0x12b3b59a	# -64.124943423745591
.COFF_Q:
	.word	0x3ff00000,0x00000000	# 1
	.word	0xc041d580,0x4b67ce0f	# -35.66797773903464
	.word	0x40738083,0xfa15267e	# 312.03222091924533
	.word	0xc0880bfe,0x9c0d9077	# -769.49932108494874
.DZERO:
	.word	0x00000000,0x00000000	# 0
.DONE:
	.word	0x3ff00000,0x00000000	# 1
.SQ_HF:
	.word	0x3fe6a09e,0x667f3bcd	# 0.70710678118654755
.DHALF:
	.word	0x3fe00000,0x00000000	# 0.5
.C2:
	.word	0xbf2bd010,0x5c610ca8	# -0.00021219444005469059
.C1:
	.word	0x3fe63000,0x00000000	# 0.693359375
.L62:
	.word	0x3fdbcb7b,0x1526e50e	# 0.43429448190325183
	.text
	.set	.F1,52
	.align	4
	.globl	log10
	.set	.R1,0
log10:
	SAVE	%fp
	MCOUNT
	ADDW2	&52,%sp
	mfcmptd	0(%ap),.DZERO
	jle	.L51

	EXTFW	&DEXP_WIDTH-1,&DEXP_OFFSET,0(%ap),%r2	# get exponent
	jz	.denormal		# If exponent zero, value is denormalized
	cmpw	%r2,&MAX_EXP
	je	.nan_inf
.norm:
	insv	&DEXP_BIAS-1,&DEXP_OFFSET,&DEXP_WIDTH,0(%ap)# Force the result
					# exponent to biased 0
	subw2	&DEXP_BIAS-1,%r2# Bias the exponent appropriately


	movw	%r2,0(%fp)
	mmovdd 0(%ap),%f2

	mmovdd	.DONE,%f1
	mfcmptd	%f2,.SQ_HF
	jge	.L55
	DECW	0(%fp)
	mmovdd	.DHALF,%f1
.L55:
# reg 3 used for temp storage rather than 4(%fp).
#	mfaddd3	%f1,%f2,%f0
#	mmovdd	%f0,4(%fp)
#
	mfaddd3	%f1,%f2,%x3
#
	mfsubd3	%f1,%f2,%x0
#
#	mfdivd2	4(%fp),%f0
#
	mfdivd2	%f3,%x0
#
	mmovdd	%f0,%f2
	mfaddd2	%f2,%x2
	mfmuld3	%f2,%f2,%x0
	mmovdd	%f0,%f1
	mfmuld3	%f1,.COFF_P,%x0
	mfaddd2	.COFF_P+8,%x0
	mfmuld2	%f1,%x0
# reg 3 used for temp storage rather than 4(%fp).
#	mfaddd2	.COFF_P+16,%f0
#	mmovdd	%f0,4(%fp)
#
	mfaddd2	.COFF_P+16,%x0
	mmovdd	%f0,%f3
#
	mfmuld3	%f1,.COFF_Q,%x0
	mfaddd2	.COFF_Q+8,%x0
	mfmuld2	%f1,%x0
	mfaddd2	.COFF_Q+16,%x0
	mfmuld2	%f1,%x0
	mfaddd2	.COFF_Q+24,%x0
	mmovdd	%f0,12(%fp)
	mfmuld3	%f1,%f2,%x0
#
#	mfmuld2	4(%fp),%f0
#
	mfmuld2	%f3,%x0
#
	mfdivd2	12(%fp),%x0
	mfaddd2	%f0,%x2
	mmovwd	0(%fp),%f0
	mmovdd	%f0,%f1
	mfmuld3	.C2,%f1,%x0
	mfaddd2	%f0,%x2
	mfmuld3	.C1,%f1,%x0
	mfaddd2	%f2,%x0
	mfmuld2	.L62,%x0
	mmovdd	%f0,4(%fp)
.out:
	MOVW	4(%fp),%r0
	MOVW	8(%fp),%r1
.L48:
	RESTORE	%fp
	RET	
.L51:
	ADDW2	&8,%sp
	mmovdd	0(%ap),-8(%sp)
	PUSHW	&.L61
	PUSHW	&5
	call	&4,log_error
	jmp	.L48

.denormal:				# number is denormal
	addw2	&1,%r2			# because exponent bias
					# for denormal numbers is -126
					# while normal bias is -127
	andw3	&SIGN_BIT,0(%ap),%r0	# remember sign

.norm_loop:				# normalization loop
	lrsw3	&31,4(%ap),%r1		# get MSB of low part
	llsw2	&1,0(%ap)			# high word << 1
	orw2	%r1,0(%ap)			# high word | msb of low word
	llsw2	&1,4(%ap)			# low word << 1
	subw2	&1,%r2			# exp--
	bitw	&IMPLIED_BIT,0(%ap)	# is fraction normalized?
	je	.norm_loop		# 	no, right shift again
					# yes,  %r2 has the right exponent
	orw2	%r0,0(%ap)			# put the sign back
	jmp	.norm			# and join main code

.nan_inf:
	MOVW	0(%ap),%r0
	MOVW	4(%ap),%r1
	ret	&0	
	.data
	.align	4
.L67:
	.double	-HGE
	.text
	.set	.F3,36
	.align	4
	.set	.R3,1
log_error:
	SAVE	%r8
	MCOUNT
	ADDW2	&36,%sp
	MOVW	8(%ap),8(%fp)
	MOVW	.L67,28(%fp)
	MOVW	.L67+4,32(%fp)
	MOVW	0(%ap),12(%fp)
	MOVW	4(%ap),16(%fp)
	mfcmpd	0(%ap),&0.0
	je	.L68
	MOVW	&1,4(%fp)
	MOVW	&.L69,%r8
	MOVW	&15,0(%fp)
	jmp	.L70
.L68:
	MOVW	&2,4(%fp)
	MOVW	&.L71,%r8
	MOVW	&13,0(%fp)
.L70:
	MOVAW	4(%fp),%r0
	PUSHW	%r0
	call	&1,matherr
	TSTW	%r0
	jne	.L72
ifdef(`UNX',`	pushw	&2',)
ifdef(`UNX',`	pushw	8(%ap)',)
ifdef(`UNX',`	pushw	12(%ap)',)
ifdef(`UNX',`	call	&3,write',)
ifdef(`UNX',`	pushw	&2',)
ifdef(`UNX',`	pushw	%r8',)
ifdef(`UNX',`	pushw	0(%fp)',)
ifdef(`UNX',`	call	&3,write',)
	MOVW	&33,errno
.L72:
	MOVW	32(%fp),%r1
	MOVW	28(%fp),%r0
	jmp	.L66
.L66:
	RESTORE	%r8
	RET	
	.data
#log10
.L61:
	.byte	108,111,103,49,48,0
#: DOMAIN error
.L69:
	.byte	58,32,68,79,77,65,73,78,32,101
	.byte	114,114,111,114,10,0
#: SING error
.L71:
	.byte	58,32,83,73,78,71,32,101,114,114
	.byte	111,114,10,0
	.text
