#	Copyright(C) 1986 AT&T.  All Rights Reserved.

#	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T.
#	The copyright notice above does not evidence any actual
#	or intended publication of such source code.

#ident	"@(#)libme:libme.mk	1.14"
#
# makefile for libme
#
# Note that the object list given in FILES is in the order in which the files
# should be added to the archive when it is created.  If the files are not
# ordered correctly, linking of libm fails on the pdp11 and is slowed down
# on other machines.

INC=$(ROOT)/usr/include
LIB=$(ROOT)/lib
LIBP=$(ROOT)/lib/libp
VARIANT =
LIBNAME = lib$(VARIANT)m.a
AR=
FILES =\
	$(LIBNAME)(asin.o)\
	$(LIBNAME)(atan.o)\
	$(LIBNAME)(erf.o)\
	$(LIBNAME)(fabs.o)\
	$(LIBNAME)(floor.o)\
	$(LIBNAME)(fmod.o)\
	$(LIBNAME)(gamma.o)\
	$(LIBNAME)(hypot.o)\
	$(LIBNAME)(jn.o)\
	$(LIBNAME)(j0.o)\
	$(LIBNAME)(j1.o)\
	$(LIBNAME)(pow.o)\
	$(LIBNAME)(log.o)\
	$(LIBNAME)(sin.o)\
	$(LIBNAME)(sinh.o)\
	$(LIBNAME)(sqrt.o)\
	$(LIBNAME)(tan.o)\
	$(LIBNAME)(tanh.o)\
	$(LIBNAME)(exp.o)\
	$(LIBNAME)(matherr.o)


all: $(LIBNAME) profiledlib

$(LIBNAME): $(FILES)
	if [ $(UX) = "unix" ] ; then \
			$(CC) -c -DUNX $(CFLAGS) *.c ; \
	else \
			$(CC) -c $(CFLAGS) *.c ; \
	fi;

	$(AR) rv $(LIBNAME) *.o
	rm -f *.o


$(FILES): $(INC)/math.h $(INC)/values.h $(INC)/errno.h \
		$(INC)/sys/errno.h

.c.a:;
profiledlib:
	make -f libme.mk -e libp.$(LIBNAME) LIBNAME=libp.$(LIBNAME) \
				CFLAGS="-p $(CFLAGS)" MAC=$(MAC)

install: all
	cp $(LIBNAME) $(LIB)/$(LIBNAME)
	cp libp.$(LIBNAME) $(LIBP)/$(LIBNAME)

clean:
	-rm -f *.o

clobber:	clean
	-rm -f $(LIBNAME) libp.$(LIBNAME)
