#	Copyright(C) 1986 AT&T.  All Rights Reserved.

#	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T.
#	The copyright notice above does not evidence any actual
#	or intended publication of such source code.

#ident	"@(#)libfm:libfm.mk	1.14"
#
# makefile for libfm
#
# Note that the object list given in FILES is in the order in which the files
# should be added to the archive when it is created.  If the files are not
# ordered correctly, linking of libfm fails on the pdp11 and is slowed down
# on other machines.

INC=$(ROOT)/usr/include
LIB=$(ROOT)/lib
LIBP=$(ROOT)/lib/libp
VARIANT =
LIBNAME = lib$(VARIANT)fm.a
LIBSA = lib$(VARIANT)fm.sa
AR=
FILES =\
	$(LIBNAME)(sin.o)\
	$(LIBNAME)(cos.o)\
	$(LIBNAME)(tan.o)\
	$(LIBNAME)(atan.o)\
	$(LIBNAME)(log.o)\
	$(LIBNAME)(log10.o)\
	$(LIBNAME)(exp.o)\
	$(LIBNAME)(sqrt.o)

all: spreproc $(LIBNAME) $(LIBSA) profiledlib

$(LIBNAME): $(FILES)
		for i in $(?:.o=); do \
			if [ -f "$$i.s" ]; then \
				$(CC) -c $(CFLAGS) $$i.s; \
			else \
				$(CC) -c $(CFLAGS) $$i.c; \
			fi; \
		done; \
	$(AR) rv $(LIBNAME) $?
	rm -f $?

$(LIBSA): $(FILES)
	$(AR) r $(LIBSA) *.s

$(FILES): ../math.m 

.c.a:;

profiledlib: ppreproc
	make -f libfm.mk -e libp.$(LIBNAME) LIBNAME=libp.$(LIBNAME) \
						CFLAGS="-p $(CFLAGS)"


spreproc: $(FILES)
		for i in $(?:.o=); do\
			m4 ../m4.def -DMCOUNT=# $$i.m > $$i.s; \
		done;

ppreproc: $(FILES)
		for i in $(?:.o=); do\
			m4 ../m4.def ../mcount.def $$i.m > $$i.s; \
		done;


install: all
	cp $(LIBNAME) $(LIB)/$(LIBNAME)
	cp $(LIBSA) $(LIB)/$(LIBSA)
	cp libp.$(LIBNAME) $(LIBP)/$(LIBNAME)

clean:
	-rm -f *.o
	-rm -f *.s

clobber:	clean
	-rm -f $(LIBNAME) libp.$(LIBNAME) $(LIBSA)
